%if 0%{?epel}
%global boost_version 157
%else
# CentOS SIGs have newer //-installable Boost
%global boost_version 159
%endif

Name:           leatherman
Version:        1.4.5
Release:        6%{?dist}.1
Summary:        A collection of C++ and CMake utility libraries

# leatherman is ASL 2.0
# bundled rapidjson is MIT

License:        ASL 2.0 and MIT
URL:            https://github.com/puppetlabs/leatherman
Source0:        https://github.com/puppetlabs/%{name}/archive/%{version}.tar.gz#/%{name}-%{version}.tar.gz

Patch0:         0001-LTH-162-Use-proc-to-close-file-descriptors.patch

# This unbundles boost-nowide and the boost libraries do not need
# to have the path to nowide added as it's included already
#
# lhh - no need for shared nowide in OSP
# Patch0:         shared_nowide.patch
Provides: bundled(boost-nowide)
Conflicts: boost-nowide

BuildRequires:  git
BuildRequires:  gcc-c++
BuildRequires:  boost-devel
BuildRequires:  cmake
BuildRequires:  curl-devel
BuildRequires:  gettext

%description
A collection of C++ and CMake utility libraries

%package        devel
Summary:        Development files for %{name}
# Building againse leatherman requires the boost nowide headers present
# Requires:       boost-nowide-devel
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       boost-devel
Provides:       bundled(boost-nowide-devel)

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.


%prep
%autosetup -Sgit -p1
# unbundle nowide
# rm -rf vendor/nowide
# leatherman isn't compatible with rapidjson 1.1.0 yet so that has to be left bundled for now
# https://tickets.puppetlabs.com/browse/LTH-130
# catch is only used in testing so can be ignored

# GCC 8 reports a class-memaccess warning treated as an error
# See https://tickets.puppetlabs.com/browse/LTH-152
%build
%cmake \
	  -DPYTHON_EXECUTABLE=%{__python3} \
          -DLEATHERMAN_SHARED=ON \
          -DLEATHERMAN_DEBUG=ON \
	  -DENABLE_CXX_WERROR=0

%make_build

%install
%make_install
#rm -rf %{buildroot}
find %{buildroot} -name '*.la' -exec rm -f {} ';'
%find_lang %{name}_logging
%find_lang %{name}_locale

%ldconfig_scriptlets


%files -f %{name}_logging.lang  -f %{name}_locale.lang
%license LICENSE
%{_libdir}/%{name}*.so.*

%files devel
%{_includedir}/%{name}
# lhh - remove when we unbundle nowide
%{_includedir}/boost/nowide
%{_libdir}/%{name}*.so
%{_libdir}/cmake/%{name}


%changelog
* Fri Apr 23 2021 CPaaS User <cpaas-ops@redhat.com> - 1.4.5-6.1
- Bump release

* Wed Mar 24 2021 Lon Hohberger <lon@redhat.com> - 1.4.5-6
- Backport a0d64254cc3a4638e443aa5ac27b61ec0e3d58a8 / LTH-162)
  Resolves: rhbz#1762794

* Tue Nov 03 2020 CPaaS User <cpaas-ops@redhat.com> - 1.4.5-5
- Bump release

* Wed Mar 06 2019 Yaakov Selkowitz <yselkowi@redhat.com> - 1.4.5-4
- Rebuilt for multi-architecture support

* Mon Feb 18 2019 Lon Hohberger <lon@redhat.com> - 1.4.5-3
- Rebase to 1.4.5; build for RHEL8 OpenStack

* Fri Feb 01 2019 Fedora Release Engineering <releng@fedoraproject.org> - 1.3.0-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Thu Jan 24 2019 Jonathan Wakely <jwakely@redhat.com> - 1.3.0-8
- Rebuilt for Boost 1.69

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.3.0-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Wed Feb 07 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.3.0-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Tue Jan 23 2018 Jonathan Wakely <jwakely@redhat.com> - 1.3.0-5
- Rebuilt for Boost 1.66

* Tue Nov 07 2017 James Hogarth <james.hogarth@gmail.com> - 1.3.0-4
- Restore catch to devel build (bz#1510392)
- Use make_build macro as per review

* Sun Oct 29 2017 Haïkel Guémar <hguemar@fedoraproject.org> - 1.3.0-3
- Merge with James spec + keep compatibility with CentOS SIGs

* Thu Oct 19 2017 James Hogarth <james.hogarth@gmail.com> - 1.3.0-2
- rebuilt

* Wed Oct 04 2017 James Hogarth <james.hogarth@gmail.com> - 1.3.0-1
- Upstream update
- unbundle nowide

* Thu Aug 31 2017 James Hogarth <james.hogarth@gmail.com> - 1.2.0-1
- Upstream update

* Sat Feb  4 2017 Haïkel Guémar <hguemar@fedoraproject.org> - 0.10.2-1
- Upstream 0.10.2
- Add Fedora support

* Thu Oct 27 2016 Haïkel Guémar <hguemar@fedoraproject.org> - 0.9.2-1
- Initial package on EL7

